#ifndef MARIO_H
#define MARIO_H

#define M_SMALL 8
#define M_BIG   16

#define M_LEFT1  0
#define M_LEFT2  1
#define M_RIGHT1 2
#define M_RIGHT2 3

#define M_WALK   0
//#define M_LITTLE 1
//#define M_SWIM   2

#define MARIO_IMMUNITY_TIME 60
// 60/20 seconds = 3 seconds

#include "box.h"

typedef struct
{
	box_t p;
	unsigned starMode :9;
	unsigned immunity :6;
	unsigned last_vx_sgn :1;
	unsigned dead :1;
	unsigned bullets :1;
} pnj;
extern pnj mario;
extern int coins;

void marioDraw();
void marioResetJump(); // resets coyote time & jump buffering (used by teleporters)
void marioMove();
void marioBigger();
void marioSmaller();

extern int global_quit;
extern int numero_frame;


#endif
